package space.kklochko.simple_jbdd.tests.factories.meta;

import space.kklochko.simple_jbdd.tests.commands.AbstractTestCommand;
import space.kklochko.simple_jbdd.tests.commands.decorators.AbstractDecorator;

import java.util.AbstractMap;
import java.util.ArrayList;

public class TestCommandMetaDataFactory extends AbstractTestCommandMetaDataFactory {
    private AbstractTestCommand command;

    public TestCommandMetaDataFactory(AbstractTestCommand command) {
        this.command = command;
    }

    public ArrayList<AbstractMap.SimpleEntry<String, String>> create() {
        ArrayList<AbstractMap.SimpleEntry<String, String>> blocks = new ArrayList<>();
        AbstractTestCommand currentCommand = command;
        Class<?> aClass = command.getClass();

        while(AbstractDecorator.class.isAssignableFrom(aClass)) {
            AbstractDecorator block = (AbstractDecorator) currentCommand;
            blocks.add(new AbstractMap.SimpleEntry<>(block.getType(), block.getLabel()));

            currentCommand = block.getCommand();
            aClass = currentCommand.getClass();
        }

        blocks.add(0, (new AbstractMap.SimpleEntry<>(currentCommand.getType(), currentCommand.getLabel())));

        return blocks;
    }
}

