package space.kklochko.simple_jbdd.tests.reports;

import space.kklochko.simple_jbdd.tests.factories.meta.AbstractTestCommandMetaDataFactory;
import space.kklochko.simple_jbdd.tests.reports.fmt.AbstractTestReportFormatter;

import java.util.AbstractMap;
import java.util.ArrayList;

public abstract class AbstractReporter {
    ArrayList<AbstractMap.SimpleEntry<AbstractTestCommandMetaDataFactory, Boolean>> Metadata;
    AbstractTestReportFormatter formatter;

    public AbstractReporter(ArrayList<AbstractMap.SimpleEntry<AbstractTestCommandMetaDataFactory, Boolean>> metadata, AbstractTestReportFormatter formatter) {
        setMetadata(metadata);
        setFormatter(formatter);
    }

    abstract public void report();

    public ArrayList<AbstractMap.SimpleEntry<AbstractTestCommandMetaDataFactory, Boolean>> getMetadata() {
        return Metadata;
    }

    public void setMetadata(ArrayList<AbstractMap.SimpleEntry<AbstractTestCommandMetaDataFactory, Boolean>> metadata) {
        Metadata = metadata;
    }

    public void addMetadata(AbstractTestCommandMetaDataFactory testMetaData, boolean isPassed) {
        getMetadata().add(new AbstractMap.SimpleEntry<>(testMetaData, isPassed));
    }

    public AbstractTestReportFormatter getFormatter() {
        return formatter;
    }

    public void setFormatter(AbstractTestReportFormatter formatter) {
        this.formatter = formatter;
    }
}

